## net.sf.saxon.expr
Class XPathContextMinor

    java.lang.Object
      net.sf.saxon.expr.XPathContextMinor

All Implemented Interfaces:
  XPathContext

Direct Known Subclasses:
  XPathContextMajor

public class XPathContextMinor
extends java.lang.Object
implements XPathContext

This class represents a minor change in the dynamic context in which an XPath expression is evaluated: a "major context" object allows all aspects of the dynamic context to change, whereas a "minor context" only allows changes to the focus and the destination for push output.

Constructor Summary
`protected` `XPathContextMinor()` Private Constructor

Method Summary
`void` `changeOutputDestination(java.util.Properties props, javax.xml.transform.Result result, boolean isFinal, int validation, SchemaType schemaType)` Set a new output destination, supplying the output format details.
`ValueRepresentation` `evaluateLocalVariable(int slotnumber)` Get the value of a local variable, identified by its slot number
`XPathContext` `getCaller()` Get the calling XPathContext (the next one down the stack).
`java.util.Comparator` `getCollation(java.lang.String name)` Get a named collation
`Item` `getContextItem()` Get the context item
`int` `getContextPosition()` Get the context position (the position of the context item)
`Controller` `getController()` Get the Controller.
`GroupIterator` `getCurrentGroupIterator()` Get the current group iterator.
`SequenceIterator` `getCurrentIterator()` Get the current iterator.
`Mode` `getCurrentMode()` Get the current mode.
`RegexIterator` `getCurrentRegexIterator()` Get the current regex iterator.
`Template` `getCurrentTemplate()` Get the current template.
`java.util.Comparator` `getDefaultCollation()` Get the default collation
`int` `getLast()` Get the context size (the position of the last item in the current node list)
`ParameterSet` `getLocalParameters()` Get the local parameters for the current template call.
`InstructionInfoProvider` `getOrigin()` Get information about the creating expression or other construct.
`int` `getOriginatingConstructType()` Get the type of location from which this context was created.
`SequenceReceiver` `getReceiver()` Get the Receiver to which output is currently being written.
`StackFrame` `getStackFrame()` Get a reference to the local stack frame for variables.
`ParameterSet` `getTunnelParameters()` Get the tunnel parameters for the current template call.
`XPathContextMajor.XSLTContext` `getXSLTContext()` Get the XSLT-specific part of the context
`boolean` `isAtLast()` Determine whether the context position is the same as the context size that is, whether position()=last()
`XPathContextMajor` `newCleanContext()` Construct a new context without copying (used for the context in a function call)
`XPathContextMajor` `newContext()` Construct a new context as a copy of another.
`XPathContextMinor` `newMinorContext()` Construct a new minor context.
`void` `setCaller(XPathContext caller)` Set the calling XPathContext
`void` `setCurrentIterator(SequenceIterator iter)` Set a new sequence iterator.
`void` `setLocalVariable(int slotnumber, ValueRepresentation value)` Set the value of a local variable, identified by its slot number
`void` `setOrigin(InstructionInfoProvider expr)` Set the creating expression (for use in diagnostics).
`void` `setOriginatingConstructType(int loc)` Set the type of creating expression (for use in diagnostics).
`void` `setReceiver(SequenceReceiver receiver)` Change the Receiver to which output is written
`void` `setTemporaryReceiver(SequenceReceiver out)` Set the output destination to write to a sequence.
`boolean` `useLocalParameter(int fingerprint, LocalParam binding, boolean isTunnel)` Use local parameter.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### XPathContextMinor

    protected XPathContextMinor()

  Private Constructor

Method Detail

### newContext

    public XPathContextMajor newContext()

  Construct a new context as a copy of another. The new context is effectively added to the top of a stack, and contains a pointer to the previous context

  Specified by:
    `newContext` in interface `XPathContext`

### newMinorContext

    public XPathContextMinor newMinorContext()

  Description copied from interface: `XPathContext`
  Construct a new minor context. A minor context can only hold new values of the focus (currentIterator) and current output destination.

  Specified by:
    `newMinorContext` in interface `XPathContext`

### setCaller

    public void setCaller(XPathContext caller)

  Set the calling XPathContext

  Specified by:
    `setCaller` in interface `XPathContext`

### newCleanContext

    public XPathContextMajor newCleanContext()

  Construct a new context without copying (used for the context in a function call)

  Specified by:
    `newCleanContext` in interface `XPathContext`

### getXSLTContext

    public XPathContextMajor.XSLTContext getXSLTContext()

  Get the XSLT-specific part of the context

  Specified by:
    `getXSLTContext` in interface `XPathContext`

### getLocalParameters

    public ParameterSet getLocalParameters()

  Get the local parameters for the current template call.

  Specified by:
    `getLocalParameters` in interface `XPathContext`
  Returns:
    the supplied parameters

### getTunnelParameters

    public ParameterSet getTunnelParameters()

  Get the tunnel parameters for the current template call.

  Specified by:
    `getTunnelParameters` in interface `XPathContext`
  Returns:
    the supplied tunnel parameters

### setOrigin

    public void setOrigin(InstructionInfoProvider expr)

  Set the creating expression (for use in diagnostics). The origin is generally set to "this" by the object that creates the new context. It's up to the debugger to determine whether this information is useful. Where possible, the object will be an `InstructionInfoProvider`, allowing information about the calling instruction to be obtained.

  Specified by:
    `setOrigin` in interface `XPathContext`

### setOriginatingConstructType

    public void setOriginatingConstructType(int loc)

  Set the type of creating expression (for use in diagnostics). When a new context is created, either this method or `setOrigin(net.sf.saxon.trace.InstructionInfoProvider)` should be called.

  Specified by:
    `setOriginatingConstructType` in interface `XPathContext`
  Parameters:
    `loc` - The originating location: the argument must be one of the integer constants in class `Location`

### getOriginatingConstructType

    public int getOriginatingConstructType()

  Get the type of location from which this context was created.

  Specified by:
    `getOriginatingConstructType` in interface `XPathContext`

### getOrigin

    public InstructionInfoProvider getOrigin()

  Get information about the creating expression or other construct.

  Specified by:
    `getOrigin` in interface `XPathContext`

### getController

    public Controller getController()

  Get the Controller. May return null when running outside XSLT or XQuery

  Specified by:
    `getController` in interface `XPathContext`

### getCaller

    public XPathContext getCaller()

  Get the calling XPathContext (the next one down the stack). This will be null if unknown, or if the bottom of the stack has been reached.

  Specified by:
    `getCaller` in interface `XPathContext`

### setCurrentIterator

    public void setCurrentIterator(SequenceIterator iter)

  Set a new sequence iterator.

  Specified by:
    `setCurrentIterator` in interface `XPathContext`

### getCurrentIterator

    public SequenceIterator getCurrentIterator()

  Get the current iterator. This encapsulates the context item, context position, and context size.

  Specified by:
    `getCurrentIterator` in interface `XPathContext`
  Returns:
    the current iterator, or null if there is no current iterator (which means the context item, position, and size are undefined).

### getContextPosition

    public int getContextPosition()
                           throws DynamicError

  Get the context position (the position of the context item)

  Specified by:
    `getContextPosition` in interface `XPathContext`
  Returns:
    the context position (starting at one)
  Throws:
    `DynamicError` - if the context position is undefined

### getContextItem

    public Item getContextItem()

  Get the context item

  Specified by:
    `getContextItem` in interface `XPathContext`
  Returns:
    the context item, or null if the context item is undefined

### getLast

    public int getLast()
                throws XPathException

  Get the context size (the position of the last item in the current node list)

  Specified by:
    `getLast` in interface `XPathContext`
  Returns:
    the context size
  Throws:
    `XPathException` - if the context position is undefined

### isAtLast

    public boolean isAtLast()
                     throws XPathException

  Determine whether the context position is the same as the context size that is, whether position()=last()

  Specified by:
    `isAtLast` in interface `XPathContext`
  Throws:
    `XPathException`

### getCollation

    public java.util.Comparator getCollation(java.lang.String name)
                                      throws XPathException

  Get a named collation

  Specified by:
    `getCollation` in interface `XPathContext`
  Throws:
    `XPathException`

### getDefaultCollation

    public java.util.Comparator getDefaultCollation()

  Get the default collation

  Specified by:
    `getDefaultCollation` in interface `XPathContext`

### getStackFrame

    public StackFrame getStackFrame()

  Get a reference to the local stack frame for variables. Note that it's the caller's job to make a local copy of this. This is used for creating a Closure containing a retained copy of the variables for delayed evaluation.

  Specified by:
    `getStackFrame` in interface `XPathContext`
  Returns:
    array of variables.

### evaluateLocalVariable

    public ValueRepresentation evaluateLocalVariable(int slotnumber)

  Get the value of a local variable, identified by its slot number

  Specified by:
    `evaluateLocalVariable` in interface `XPathContext`

### setLocalVariable

    public void setLocalVariable(int slotnumber,
                                 ValueRepresentation value)

  Set the value of a local variable, identified by its slot number

  Specified by:
    `setLocalVariable` in interface `XPathContext`

### changeOutputDestination

    public void changeOutputDestination(java.util.Properties props,
                                        javax.xml.transform.Result result,
                                        boolean isFinal,
                                        int validation,
                                        SchemaType schemaType)
                                 throws XPathException

  Set a new output destination, supplying the output format details.
  This affects all further output until resetOutputDestination() is called. Note that it is the caller's responsibility to close the Writer after use.

  Specified by:
    `changeOutputDestination` in interface `XPathContext`
  Parameters:
    `props` - properties defining the output format
    `result` - Details of the new output destination
    `isFinal` - true if the destination is a final result tree (either the principal output or a secondary result tree); false if it is a temporary tree, xsl:attribute, etc.
  Throws:
    `XPathException` - if any dynamic error occurs; and specifically, if an attempt is made to switch to a final output destination while writing a temporary tree or sequence

### setTemporaryReceiver

    public void setTemporaryReceiver(SequenceReceiver out)

  Set the output destination to write to a sequence.
  This affects all further output until resetOutputDestination() is called.

  Specified by:
    `setTemporaryReceiver` in interface `XPathContext`
  Parameters:
    `out` - The SequenceReceiver to be used

### setReceiver

    public void setReceiver(SequenceReceiver receiver)

  Change the Receiver to which output is written

  Specified by:
    `setReceiver` in interface `XPathContext`

### getReceiver

    public SequenceReceiver getReceiver()

  Get the Receiver to which output is currently being written.

  Specified by:
    `getReceiver` in interface `XPathContext`
  Returns:
    the current Receiver

### useLocalParameter

    public boolean useLocalParameter(int fingerprint,
                                     LocalParam binding,
                                     boolean isTunnel)
                              throws XPathException

  Use local parameter. This is called when a local xsl:param element is processed. If a parameter of the relevant name was supplied, it is bound to the xsl:param element. Otherwise the method returns false, so the xsl:param default will be evaluated

  Specified by:
    `useLocalParameter` in interface `XPathContext`
  Parameters:
    `fingerprint` - The fingerprint of the parameter name
    `binding` - The XSLParam element to bind its value to
    `isTunnel` - True if a tunnel parameter is required, else false
  Returns:
    true if a parameter of this name was supplied, false if not
  Throws:
    `XPathException`

### getCurrentMode

    public Mode getCurrentMode()

  Get the current mode.

  Specified by:
    `getCurrentMode` in interface `XPathContext`
  Returns:
    the current mode

### getCurrentTemplate

    public Template getCurrentTemplate()

  Get the current template. This is used to support xsl:apply-imports

  Specified by:
    `getCurrentTemplate` in interface `XPathContext`
  Returns:
    the current template

### getCurrentGroupIterator

    public GroupIterator getCurrentGroupIterator()

  Get the current group iterator. This supports the current-group() and current-grouping-key() functions in XSLT 2.0

  Specified by:
    `getCurrentGroupIterator` in interface `XPathContext`
  Returns:
    the current grouped collection

### getCurrentRegexIterator

    public RegexIterator getCurrentRegexIterator()

  Get the current regex iterator. This supports the functionality of the regex-group() function in XSLT 2.0.

  Specified by:
    `getCurrentRegexIterator` in interface `XPathContext`
  Returns:
    the current regular expressions iterator